#version 430



vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}

layout(triangles) in;
layout(triangle_strip, max_vertices = 15) out;
//layout(line_strip, max_vertices = 15) out;

in vec3 normal[3];
in vec2 uv[3];
in vec3 tangent[3];
in vec4 origPos[3];

out vec4 posG;
out vec3 normalG;
out vec2 uvG;
out vec3 tangentG;
out vec3 colorG;

uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform float g_time;

uniform float windowWidth;
uniform float windowHeight;

uniform float furLength = 1.0;

// uniform float makkara;

layout(binding=0) uniform sampler2D tex;

void main(void) {

        float makkara = furLength*clamp(0.50+1.50*sin(g_time*0.4), 0.0, 1.0)*0.1+0.01;


	float times = g_time*0.1;
       vec3 faceNormal = vec3(0.0);
	vec4 facePos = vec4(0.0);
	for (int i = 0; i < gl_in.length(); ++i) {
		gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
		facePos += origPos[i];
        //	gl_Position.xyz -= normal[i]*1.5;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
		colorG = vec3(0.10, 0.2, 0.25);
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		posG = gl_Position;
		faceNormal += normal[i];
		uvG = uv[i];
		tangentG = tangent[i];
                tangentG = (modelViewMatrix * vec4(tangentG, 0.0)).xyz;
        //         EmitVertex();
	}
	facePos /= 3.0;

         EndPrimitive();

       vec4 vertTex = texture2D(tex, uv[0]);

        int ii=0;
        vec4 posAccu = gl_in[0].gl_Position;
        float velDown = 3.10;
        float velAccu = 0.0;

        float karvaPituus = vertTex.g;

        float karvaFreq = 1.0;

        karvaPituus = 1.0+0.0*clamp((karvaPituus-(1.0-karvaFreq))/karvaFreq, 0.0, 1.0);

        makkara = karvaPituus*0.2;

        // int karvaPituusI = 16*karvaPituus;

        for (int i = 0; i < karvaPituus*3; ++i) {

                gl_Position = posAccu;
                if (ii==1) {
                  gl_Position += vec4(0.005, 0.005, 0.0, 0.0);
                }
                if (ii==1) {
                  velAccu += velDown;
                  velDown -= 0.25;
                  posAccu += vec4(faceNormal, 0.0)*0.050*makkara-0.0*origPos[0]*1.51;
                  posAccu += vec4(0.0, 1.0, 0.0, 0.0)*0.03*velAccu;
                }

             //  gl_Position.xyz -= normal[i].xyz*2.0;

//            gl_Position = gl_in[i].gl_Position;
////            //gl_Position.xyz -= normal[i].xyz*12.0*why;
//          //  gl_Position += rotateXZ(origPos[i], why*5.0);
//            gl_Position.xyz -= faceNormal*1.0*why;

                //gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                gl_Position = projectionMatrix * modelViewMatrix * gl_in[i%3].gl_Position;
                normalG = normal[i%3];
                colorG = mix(vec3(0.150, 0.150, 0.50),vec3(1.5,0.91,0.91), 0.0*0.2)*0.20;
                normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
                uvG = uv[i%3];
                tangentG = tangent[i%3];
                posG = gl_Position;

                ii++;
                if (ii>1) {
                    ii=0;
                }
                EmitVertex();
        }
        EndPrimitive();


}
