#version 430



vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec3 rotateXY3(vec3 p, float a) {
  vec3 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}
vec3 rotateYZ3(vec3 p, float a) {
  vec3 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}


layout(triangles) in;
layout(triangle_strip, max_vertices = 16) out;
//layout(line_strip, max_vertices = 15) out;

in vec3 normal[3];
in vec2 uv[3];
in vec3 tangent[3];
in vec4 origPos[3];
in float mak[3];

out vec4 posG;
out vec3 normalG;
out vec2 uvG;
out vec3 colorG;
out vec3 tangentG;
 
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform float g_time;

uniform float windowWidth;
uniform float windowHeight;

uniform float furLength = 1.0;

// uniform float makkara;

uniform float g_shatter = 0.0;

layout(binding=0) uniform sampler2D tex;

void main(void) {

        float makkara = furLength*clamp(0.50+1.50*sin(g_time*0.04), 0.0, 1.0)*0.1+0.01;


        float times = g_time*0.1;
       vec3 faceNormal = vec3(0.0);
	vec4 facePos = vec4(0.0);

        vec4 posC = vec4(0.0);
        vec3 norC = vec3(0.0);
        vec3 tanC = vec3(0.0);
        vec2 uvC = vec2(0.0);

            vec4 pos;
            vec3 nor;
            vec2 uvm;
            vec3 tang;


	for (int i = 0; i < gl_in.length(); ++i) {

                pos = gl_in[i].gl_Position;
                nor = normal[i];
                uvm = uv[i];
                tang = tangent[i];

		gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
		facePos += origPos[i];
        //	gl_Position.xyz -= normal[i]*1.5;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
		colorG = vec3(0.10, 0.2, 0.25);
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		posG = gl_Position;
		faceNormal += normal[i];
		uvG = uv[i];
		tangentG = tangent[i];


            posC += pos;
            norC += nor;
            uvC += uvm;
            tanC += tang;
         //        EmitVertex();
	}
	facePos /= 3.0;

                posC *= 1.0/3.0;
                norC *= 1.0/3.0;
                uvC *= 1.0/3.0;
                tanC *= 1.0/3.0;

//            tanC = tangent[0];
//            norC = normal[0];
//            uvC = uv[0];


     //    EndPrimitive();
	
	vec4 inp = facePos;
	// vec4 inp = ;
        float lim = 0.7;
        float why = 12.0*pow((clamp(sin((inp.y*0.10-0.0*fract(inp.y*0.350))+g_shatter*10.0)*1.0, lim, 1.0)-lim)/(1.0-lim),1.0);


        int ii=0;

            float whyx = why;
        for (int i = 0; i < 6; i++) {

            if (i==3) {
                pos = posC;
                pos.xyz += -faceNormal*0.11*(1.0-mak[0]);
                nor = -faceNormal;
                uvm = uvC;
                tang = -tanC;
                ii=0;
            } else if (i==4) {
              ii=0;
            }
            if (i!=3) {
                pos = gl_in[ii].gl_Position;
                nor = normal[ii];
                uvm = uv[ii];
                tang = tangent[ii];
            }


                vec4 inp = pos;
    //	why = 1.50*pow((clamp(sin((inp.y*0.10)+g_time*0.4)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);
                // float lim = 0.75;
               float why = 8.0*pow((clamp(sin(inp.y*0.25+g_shatter*11.0*0.25)*1.0, lim, 1.0)-lim)/(1.0-lim),1.0);
            whyx = why;

            float rotXY = clamp(whyx-1.5, 0.0, 100.0)*(1.0-mak[0])*3.5;

            pos = pos - posC + vec4(faceNormal*0.05, 0.0);
            pos = rotateXY(pos, rotXY);
            pos = rotateXZ(pos, rotXY*0.5);
            pos = pos + posC - vec4(faceNormal*0.05, 0.0);

            nor = rotateXY3(nor, rotXY);
            nor = rotateXZ3(nor, rotXY*0.5);
            tang = rotateXY3(tang, rotXY);
            tang = rotateXZ3(tang, rotXY*0.5);

                ii++;


                gl_Position = pos+vec4(faceNormal*1.180*whyx, 0.0);
                gl_Position += vec4(nor*0.020*why, 0.0);
            //    gl_Position.xz += (faceNormal.xz*why*30.0);
              //  gl_Position = rotateXZ(gl_Position, why*5.0);
         //       gl_Position.xyz += (normal[i].xyz*why*12.0);
    //	gl_Position.xz += (normal[i].xz*why*32.0);
                // gl_Position = gl_Position*(1.0-why)+1.0*origPos[i]*why;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                normalG = nor;
                colorG = 2.0*vec3(0.40, 0.30, 0.420)*(1.0-why*0.0)+vec3(1.1,1.81,0.31)*why*0.0;
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
                uvG = uvm;
                tangentG = tang;
		posG = gl_Position;
               EmitVertex();
	}
        EndPrimitive();



/*

        for (int i = 0; i < 12; i++) {

            if (i==3) {
                pos = posC;
                pos.xyz += -faceNormal*0.175*(1.0-mak[0]);
                nor = -faceNormal;
                uvm = uvC;
                tang = -tanC;
                ii=0;
            } else if (i==4) {
              ii=0;
            }
            if (i!=3) {
                pos = gl_in[ii].gl_Position;
                nor = normal[ii];
                uvm = uv[ii];
                tang = tangent[ii];
            }

                ii++;


                vec4 inp = pos;
    //	why = 1.50*pow((clamp(sin((inp.y*0.10)+g_time*0.4)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);
                // float lim = 0.75;
                 float why = 8.0*pow((clamp(sin(inp.y*0.25+g_time*0.25)*1.0, lim, 1.0)-lim)/(1.0-lim),1.0);
                gl_Position = pos+vec4(faceNormal*0.180*why, 0.0);
                gl_Position += vec4(nor*0.020*why, 0.0);
            //    gl_Position.xz += (faceNormal.xz*why*30.0);
              //  gl_Position = rotateXZ(gl_Position, why*5.0);
         //       gl_Position.xyz += (normal[i].xyz*why*12.0);
    //	gl_Position.xz += (normal[i].xz*why*32.0);
                // gl_Position = gl_Position*(1.0-why)+1.0*origPos[i]*why;
                gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                normalG = nor;
                colorG = 2.0*vec3(0.40, 0.30, 0.420)*(1.0-why*0.0)+vec3(1.1,1.81,0.31)*why*0.0;
                normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
                uvG = uvm;
                tangentG = tang;
                posG = gl_Position;
               EmitVertex();
        }
        EndPrimitive();

        */
	
}
