#version 430



vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}

layout(triangles) in;
layout(triangle_strip, max_vertices = 15) out;
//layout(line_strip, max_vertices = 15) out;

in vec3 normal[3];
in vec2 uv[3];
in vec3 tangent[3];
in vec4 origPos[3];

out vec4 posG;
out vec3 normalG;
out vec2 uvG;
out vec3 colorG;
out vec3 tangentG;
out vec3 controlG;

out vec4 posMG;
 
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform mat4 modelMatrix;

uniform float g_time;

uniform float windowWidth;
uniform float windowHeight;

uniform float g_exploWeight = 0.0;

// uniform float makkara;

void main(void) {

        float makkara = g_exploWeight;

        vec3 controlBase = vec3(0.0);


	float times = g_time*0.1;
       vec3 faceNormal = vec3(0.0);
	vec4 facePos = vec4(0.0);
	for (int i = 0; i < gl_in.length(); ++i) {
                gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
                gl_Position.xyz -= normal[i]*0.1;
		facePos += origPos[i];
        //	gl_Position.xyz -= normal[i]*1.5;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                 posMG = modelMatrix*gl_Position;
		normalG = normal[i];
                colorG = vec3(1.90, 0.92, 0.9925)*5.0;
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		posG = gl_Position;
                controlG = controlBase;
                controlG.r = 0.1;
		faceNormal += normal[i];
		uvG = uv[i];
		tangentG = tangent[i];
      //          EmitVertex();
	}
	facePos /= 3.0;

        EndPrimitive();

//return;

        vec4 inp = facePos;
        // vec4 inp = ;
        float lim = -10.0;
        float why = 3.0*pow((clamp(sin((inp.y*0.1350-fract(inp.y*0.1350))+times*0.004)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);


        for (int i = 0; i < gl_in.length(); ++i) {
                gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0)
                gl_Position.xyz += faceNormal*why*0.10*makkara;
        //	gl_Position.xyz -= normal[i]*1.5;
                gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                 posMG = modelMatrix*gl_Position;
                normalG = normal[i];
                colorG = vec3(0.90, 0.92, 0.9925);
                normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
                posG = gl_Position;
                controlG = controlBase;

                faceNormal += normal[i];
                uvG = uv[i];
                tangentG = tangent[i];
                EmitVertex();
        }

        EndPrimitive();

        for (int i = 0; i < gl_in.length(); ++i) {
                vec4 inp = gl_in[i].gl_Position;
    //	why = 1.50*pow((clamp(sin((inp.y*0.10)+g_time*0.4)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);
                // float lim = 0.75;
                // float why = 8.0*pow((clamp(sin(inp.y*0.1+g_time)*1.0, lim, 1.0)-lim)/(1.0-lim),1.0);
                gl_Position = gl_in[i].gl_Position+vec4(faceNormal*2.0*why, 0.0);
        //	gl_Position = gl_in[i].gl_Position+vec4(normal[i]*10.0*why, 0.0);
            //    gl_Position.xz += (faceNormal.xz*why*30.0);
              //  gl_Position = rotateXZ(gl_Position, why*5.0);
           //     gl_Position.xyz += (normal[i].xyz*why*12.0);
    //	gl_Position.xz += (normal[i].xz*why*32.0);
                // gl_Position = gl_Position*(1.0-why)+1.0*origPos[i]*why;
                gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
                normalG = -normal[i];
                controlG = controlBase;

                colorG = 20.0*vec3(0.40, 0.30, 0.420)*(1.0-why*0.0)+vec3(1.1,1.81,0.31)*why*0.0;
                normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
                uvG = uv[i];
                tangentG = tangent[i];
                posG = gl_Position;
    //           EmitVertex();
        }
        EndPrimitive();



}
