#version 430

vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}

layout(triangles) in;
layout(triangle_strip, max_vertices = 15) out;

in vec3 normal[3];
in vec2 uv[3];
in vec3 tangent[3];
in vec4 origPos[3];
in vec3 posInV[3];

out vec4 posG;
out vec3 normalG;
out vec2 uvG;
out vec3 tangentG;
out vec3 colorG;

out float godrayG;

out vec3 posInG;

out vec4 posMG;

uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform mat4 modelMatrix;

uniform float g_time;

uniform float windowWidth;
uniform float windowHeight;

uniform float furLength = 1.0;

layout(binding=0) uniform sampler2D tex;

uniform float g_meshExplo = 0.0;

void main(void) {

    vec3 controlBase = vec3(0.0);

    float times = g_time*0.1;
    vec3 faceNormal = vec3(0.0);
    vec4 facePos = vec4(0.0);
    for (int i = 0; i < gl_in.length(); ++i) {
        gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
        facePos += origPos[i];
        posMG = modelMatrix*gl_Position;
        gl_Position = projectionMatrix*modelViewMatrix*gl_Position;
        normalG = normal[i];
        normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
        colorG = vec3(1.0, 1.0, 1.0)*1.0;
        godrayG = 1.0;
        posG = gl_Position;
        faceNormal += normal[i];
        uvG = uv[i];
        posInG = posInV[i];
        tangentG = tangent[i];
        EmitVertex();
    }
    facePos /= 3.0;

    EndPrimitive();


    for (int i = 0; i < gl_in.length(); ++i) {
        gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
        gl_Position.xyz *= 1.0;
        gl_Position.x += 0.0;
        gl_Position.xyz += faceNormal*g_meshExplo+normal[i]*0.01;

        posMG = modelMatrix*gl_Position;
        gl_Position = modelViewMatrix * gl_Position;
        gl_Position = projectionMatrix* gl_Position;
        normalG = normal[i];
        normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
        colorG = vec3(1.0, 1.0, 2.0)*1.0;
        godrayG = 0.0;
        posG = gl_Position;
        uvG = uv[i];
        posInG = posInV[i];
        tangentG = tangent[i];
        EmitVertex();
    }

    EndPrimitive();



}
